package com.engine.salary.mapper.salarysob;

import com.engine.salary.entity.salarysob.po.SalarySobItemHidePO;
import com.engine.salary.entity.salarysob.po.SalarySobItemPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;


public interface SalarySobItemMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalarySobItemPO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobItemPO> listSome(SalarySobItemPO salarySobItemPO);

	List<SalarySobItemPO> listBySalarySobIdWithHideItem(SalarySobItemPO salarySobItemPO);


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalarySobItemPO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param salarySobItemPO 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalarySobItemPO salarySobItemPO);
	
	/**
     * 修改，修改所有字段
     *
     * @param salarySobItemPO 修改的记录
     * @return 返回影响行数
     */
	int update(SalarySobItemPO salarySobItemPO);
	
	/**
     * 修改，忽略null字段
     *
     * @param salarySobItemPO 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalarySobItemPO salarySobItemPO);
	
	/**
     * 删除记录
     *
     * @param salarySobItemPO 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalarySobItemPO salarySobItemPO);


	/**
	 * 根据薪资账套id删除
	 *
	 * @param salarySobIds
	 */
	void deleteBySalarySobIds(@Param("salarySobIds") Collection<Long> salarySobIds);

	/**
	 * 根据主键id删除
	 *
	 * @param ids
	 */
	void deleteByIds(@Param("ids") Collection<Long> ids);

	/**
	 * 批量保存
	 *
	 * @param salarySobItems
	 */
	void batchInsert(@Param("collection") Collection<SalarySobItemPO> salarySobItems);


	/**
	 * 删除工资项目是否显示
	 *
	 * @param salarySobIds
	 */
	void deleteItemShowBySalarySobId(@Param("salarySobIds")Collection<Long> salarySobIds);

	/**
	 * 插入薪资项目分组是否显示
	 * @param salarySobItemHidePO
	 */
	void insertItemShow(SalarySobItemHidePO salarySobItemHidePO);

	/**
	 * 根据账套id以及薪资项目分组获取
	 * @param
	 */
	List<SalarySobItemPO> listBySalarySobIdAndGroupId(@Param("salarySobId") Long salarySobId,@Param("salarySobItemGroupIds") Collection<Long> salarySobItemGroupIds);


	void deleteByGroupIds(@Param("groupIds") List<Long> needDeleteGroupIds);

	/**
	 * 批量插入薪资项目分组是否显示
	 * @param list
	 */
	void batchInsertItemShow(@Param("collection")List<SalarySobItemHidePO> list);
}